diff --git a/src/tds/bulk.c b/src/tds/bulk.c
index f549571..e0c4ffb 100644
--- a/src/tds/bulk.c
+++ b/src/tds/bulk.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: bulk.c,v 1.9 2009/01/16 20:27:58 jklowden Exp $");
+TDS_RCSID(var, "$Id: bulk.c,v 1.10 2009/08/25 14:25:35 freddy77 Exp $");
 
 #ifndef MAX
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
@@ -829,7 +829,7 @@ tds7_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 			continue;
 		}
 
-		if (IS_TDS90(tds))
+		if (IS_TDS72(tds))
 			tds_put_int(tds, bcpcol->column_usertype);
 		else
 			tds_put_smallint(tds, bcpcol->column_usertype);
@@ -856,7 +856,7 @@ tds7_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 			tds_put_byte(tds, bcpcol->column_prec);
 			tds_put_byte(tds, bcpcol->column_scale);
 		}
-		if (IS_TDS8_PLUS(tds)
+		if (IS_TDS71_PLUS(tds)
 			&& is_collate_type(bcpcol->on_server.column_type)) {
 			tds_put_n(tds, bcpcol->column_collation, 5);
 		}
diff --git a/src/tds/config.c b/src/tds/config.c
index f1ba176..faa32eb 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.144 2009/08/20 17:51:15 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.145 2009/08/25 14:25:35 freddy77 Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -209,8 +209,8 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 		tdsdump_log(TDS_DBG_INFO1, "Final connection parameters:\n");
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "server_name", tds_dstr_cstr(&connection->server_name));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "port", connection->port);
-		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "major_version", (int)connection->major_version);
-		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "minor_version", (int)connection->minor_version);
+		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "major_version", TDS_MAJOR(connection));
+		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "minor_version", TDS_MINOR(connection));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %d\n", "block_size", connection->block_size);
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "language", tds_dstr_cstr(&connection->language));
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "server_charset", tds_dstr_cstr(&connection->server_charset));
@@ -582,10 +582,8 @@ tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login)
 	if (!tds_dstr_isempty(&login->server_name) && tds_dstr_isempty(&connection->server_name)) {
 		tds_dstr_dup(&connection->server_name, &login->server_name);
 	}
-	if (login->major_version || login->minor_version) {
-		connection->major_version = login->major_version;
-		connection->minor_version = login->minor_version;
-	}
+	if (login->tds_version)
+		connection->tds_version = login->tds_version;
 	if (!tds_dstr_isempty(&login->language)) {
 		tds_dstr_dup(&connection->language, &login->language);
 	}
@@ -704,32 +702,30 @@ tds_config_env_tdshost(TDSCONNECTION * connection)
  * @param connection where to store information
  * @return as encoded hex value: high nybble major, low nybble minor.
  */
-unsigned char
+TDS_USMALLINT
 tds_config_verstr(const char *tdsver, TDSCONNECTION * connection)
 {
-	unsigned char version;
+	TDS_USMALLINT version;
 
 	if (!strcmp(tdsver, "42") || !strcmp(tdsver, "4.2"))
-		version = 0x42;
+		version = 0x402;
 	else if (!strcmp(tdsver, "46") || !strcmp(tdsver, "4.6"))
-		version = 0x46;
+		version = 0x406;
 	else if (!strcmp(tdsver, "50") || !strcmp(tdsver, "5.0"))
-		version = 0x50;
+		version = 0x500;
 	else if (!strcmp(tdsver, "70") || !strcmp(tdsver, "7.0"))
-		version = 0x70;
+		version = 0x700;
 	else if (!strcmp(tdsver, "80") || !strcmp(tdsver, "8.0") || !strcmp(tdsver, "7.1"))
-		version = 0x80;
+		version = 0x701;
 	else if (!strcmp(tdsver, "7.2"))
-		version = 0x90;
+		version = 0x702;
 	else if (!strcmp(tdsver, "0.0"))
 		version = 0;
 	else 
 		return 0;
 
-	if (connection) {
-		connection->major_version = version >> 4;
-		connection->minor_version = version & 0xf;
-	}
+	if (connection)
+		connection->tds_version = version;
 
 	return version;
 }
@@ -1143,21 +1139,17 @@ tds_get_compiletime_settings(void)
 #		endif
 #		ifdef TDS46
 			, "4.6"
-#		else
-#		ifdef TDS50
+#		elif TDS50
 			, "5.0"
-#		else
-#		ifdef TDS70
+#		elif TDS70
 			, "7.0"
-#		else
-#		ifdef TDS80
-			, "8.0"
+#		elif TDS71
+			, "7.1"
+#		elif TDS72
+			, "7.2"
 #		else
 			, "4.2"
 #		endif
-#		endif
-#		endif
-#		endif
 #		ifdef IODBC
 			, 1
 #		else
diff --git a/src/tds/login.c b/src/tds/login.c
index 3f5de67..cc49cf8 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.187 2009/08/20 17:51:15 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.188 2009/08/25 14:25:35 freddy77 Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -60,8 +60,7 @@ static int tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 void
 tds_set_version(TDSLOGIN * tds_login, TDS_TINYINT major_ver, TDS_TINYINT minor_ver)
 {
-	tds_login->major_version = major_ver;
-	tds_login->minor_version = minor_ver;
+	tds_login->tds_version = ((TDS_USMALLINT) major_ver << 8) + minor_ver;
 }
 
 void
@@ -333,22 +332,19 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	 * A major version of 0 means try to guess the TDS version. 
 	 * We try them in an order that should work. 
 	 */
-	const static struct tdsver {
-		TDS_TINYINT major_version;
-		TDS_TINYINT minor_version;
-	} versions[] =
-		{ { 9, 0 }
-		, { 8, 0 }
-		, { 7, 0 }
-		, { 5, 0 }
-		, { 4, 2 }
+	const static TDS_USMALLINT versions[] =
+		{ 0x702
+		, 0x701
+		, 0x700
+		, 0x500
+		, 0x402
 		};
 
 	/* disable tds9 if iconv wanted, currently not supported */
-	if (connection->major_version == 9 && tds->use_iconv)
-		connection->major_version = 8;
+	if (IS_TDS72(connection) && tds->use_iconv)
+		connection->tds_version = 0x701;
 
-	if (connection->major_version == 0) {
+	if (TDS_MAJOR(connection) == 0) {
 		unsigned int i;
 		TDSSAVECONTEXT save_ctx;
 		const TDSCONTEXT *old_ctx = tds->tds_ctx;
@@ -364,8 +360,7 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		mod_ctx->err_handler = NULL;
 
 		for (i=tds->use_iconv ? 1: 0; i < TDS_VECTOR_SIZE(versions); ++i) {
-			connection->major_version = versions[i].major_version;
-			connection->minor_version = versions[i].minor_version;
+			connection->tds_version = versions[i];
 			reset_save_context(&save_ctx);
 
 			if ((erc = tds_connect_and_login(tds, connection)) != TDS_SUCCEED) {
@@ -400,8 +395,7 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 
 	tds->connection = connection;
 
-	tds->major_version = connection->major_version;
-	tds->minor_version = connection->minor_version;
+	tds->tds_version = connection->tds_version;
 	tds->emul_little_endian = connection->emul_little_endian;
 #ifdef WORDS_BIGENDIAN
 	if (IS_TDS7_PLUS(tds)) {
@@ -462,7 +456,7 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 		
 	tds_set_state(tds, TDS_IDLE);
 
-	if (IS_TDS8_PLUS(tds)) {
+	if (IS_TDS71_PLUS(tds)) {
 		erc = tds8_do_login(tds, connection);
 		db_selected = 1;
 	} else if (IS_TDS7_PLUS(tds)) {
@@ -747,7 +741,7 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	if (password_len > 128)
 		password_len = 128;
 
-	current_pos = IS_TDS90(tds) ? 86 + 8 : 86;	/* ? */
+	current_pos = IS_TDS72(tds) ? 86 + 8 : 86;	/* ? */
 
 	packet_size = current_pos + (host_name_len + app_name_len + server_name_len + library_len + language_len + database_len) * 2;
 
@@ -777,9 +771,9 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	tdsdump_off();
 #endif
 	TDS_PUT_INT(tds, packet_size);
-	if (IS_TDS90(tds)) {
+	if (IS_TDS72(tds)) {
 		tds_put_n(tds, tds9Version, 4);
-	} else if (IS_TDS8_PLUS(tds)) {
+	} else if (IS_TDS71_PLUS(tds)) {
 		tds_put_n(tds, tds8Version, 4);
 	} else {
 		tds_put_n(tds, tds7Version, 4);
@@ -873,7 +867,7 @@ tds7_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	TDS_PUT_SMALLINT(tds, current_pos);
 	tds_put_smallint(tds, 0);
 
-	if (IS_TDS90(tds)) {
+	if (IS_TDS72(tds)) {
 		TDS_PUT_SMALLINT(tds, current_pos);
 		tds_put_smallint(tds, 0);
 
@@ -965,7 +959,7 @@ tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	TDS_UCHAR *p;
 
 	SET_UI16BE(13, instance_name_len);
-	if (!IS_TDS90(tds)) {
+	if (!IS_TDS72(tds)) {
 		SET_UI16BE(16, START_POS + 6 + 1 + instance_name_len);
 		buf[20] = 0xff;
 	} else {
@@ -987,7 +981,7 @@ tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 
 	tds_put_n(tds, buf, start_pos);
 	/* netlib version */
-	tds_put_n(tds, IS_TDS90(tds) ? netlib9 : netlib8, 6);
+	tds_put_n(tds, IS_TDS72(tds) ? netlib9 : netlib8, 6);
 	/* encryption */
 #if !defined(HAVE_GNUTLS) && !defined(HAVE_OPENSSL)
 	/* not supported */
@@ -1000,7 +994,7 @@ tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	/* pid */
 	tds_put_int(tds, getpid());
 	/* MARS (1 enabled) */
-	if (IS_TDS90(tds))
+	if (IS_TDS72(tds))
 		tds_put_byte(tds, 0);
 	if (tds_flush_packet(tds) == TDS_FAIL)
 		return TDS_FAIL;
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 33edd1a..3616d78 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.190 2009/07/20 17:38:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.191 2009/08/25 14:25:35 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -812,8 +812,7 @@ tds_alloc_connection(TDSLOCALE * locale)
 	/* fill in all hardcoded defaults */
 	if (!tds_dstr_copy(&connection->server_name, TDS_DEF_SERVER))
 		goto Cleanup;
-	connection->major_version = TDS_DEF_MAJOR;
-	connection->minor_version = TDS_DEF_MINOR;
+	connection->tds_version = TDS_DEFAULT_VERSION;
 	connection->port = TDS_DEF_PORT;
 	connection->block_size = 0;
 	/* TODO use system default ?? */
diff --git a/src/tds/net.c b/src/tds/net.c
index 394ac99..f93cdff 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -107,7 +107,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.94 2009/08/21 10:01:52 freddy77 Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.95 2009/08/25 14:25:35 freddy77 Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL) && !defined(C_INTERIX)
@@ -220,7 +220,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 
 	tdsdump_log(TDS_DBG_INFO1, "Connecting to %s port %d (TDS version %d.%d)\n", 
 			tds_inet_ntoa_r(sin.sin_addr, ip, sizeof(ip)), ntohs(sin.sin_port), 
-			tds->major_version, tds->minor_version);
+			TDS_MAJOR(tds), TDS_MINOR(tds));
 
 	if (TDS_IS_SOCKET_INVALID(tds->s = socket(AF_INET, SOCK_STREAM, 0))) {
 		tds->oserr = sock_errno;
diff --git a/src/tds/query.c b/src/tds/query.c
index 41d2b0f..0e96adb 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.239 2009/08/20 17:51:15 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.240 2009/08/25 14:25:35 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len);
@@ -249,7 +249,7 @@ static const TDS_UCHAR tds9_query_start[] = {
 
 #define START_QUERY \
 do { \
-	if (IS_TDS90(tds)) \
+	if (IS_TDS72(tds)) \
 		tds_start_query(tds); \
 } while(0)
 
@@ -353,7 +353,7 @@ tds_submit_query_params(TDSSOCKET * tds, const char *query, TDSPARAMINFO * param
 		tds->out_flag = TDS_RPC;
 		START_QUERY;
 		/* procedure name */
-		if (IS_TDS8_PLUS(tds)) {
+		if (IS_TDS71_PLUS(tds)) {
 			tds_put_smallint(tds, -1);
 			tds_put_smallint(tds, TDS_SP_EXECUTESQL);
 		} else {
@@ -368,7 +368,7 @@ tds_submit_query_params(TDSSOCKET * tds, const char *query, TDSPARAMINFO * param
 			tds_put_byte(tds, 0);
 			tds_put_byte(tds, SYBNTEXT);	/* must be Ntype */
 			TDS_PUT_INT(tds, converted_query_len);
-			if (IS_TDS8_PLUS(tds))
+			if (IS_TDS71_PLUS(tds))
 				tds_put_n(tds, tds->collation, 5);
 			TDS_PUT_INT(tds, converted_query_len);
 			tds_put_n(tds, converted_query, converted_query_len);
@@ -948,7 +948,7 @@ tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len)
 	tds_put_byte(tds, SYBNTEXT);	/* must be Ntype */
 	len = 2u * len + query_len;
 	TDS_PUT_INT(tds, len);
-	if (IS_TDS8_PLUS(tds))
+	if (IS_TDS71_PLUS(tds))
 		tds_put_n(tds, tds->collation, 5);
 	TDS_PUT_INT(tds, len);
 	s = query;
@@ -977,7 +977,7 @@ tds7_put_params_definition(TDSSOCKET * tds, const char *param_definition, size_t
 
 	/* put parameters definitions */
 	TDS_PUT_INT(tds, param_length);
-	if (IS_TDS8_PLUS(tds))
+	if (IS_TDS71_PLUS(tds))
 		tds_put_n(tds, tds->collation, 5);
 	TDS_PUT_INT(tds, param_length ? param_length : -1);
 	tds_put_n(tds, param_definition, param_length);
@@ -1056,7 +1056,7 @@ tds_submit_prepare(TDSSOCKET * tds, const char *query, const char *id, TDSDYNAMI
 		tds->out_flag = TDS_RPC;
 		START_QUERY;
 		/* procedure name */
-		if (IS_TDS8_PLUS(tds)) {
+		if (IS_TDS71_PLUS(tds)) {
 			tds_put_smallint(tds, -1);
 			tds_put_smallint(tds, TDS_SP_PREPARE);
 		} else {
@@ -1170,7 +1170,7 @@ tds_submit_execdirect(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params)
 		tds->out_flag = TDS_RPC;
 		START_QUERY;
 		/* procedure name */
-		if (IS_TDS8_PLUS(tds)) {
+		if (IS_TDS71_PLUS(tds)) {
 			tds_put_smallint(tds, -1);
 			tds_put_smallint(tds, TDS_SP_EXECUTESQL);
 		} else {
@@ -1386,7 +1386,7 @@ tds_put_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags)
 	}
 
 	/* TDS8 output collate information */
-	if (IS_TDS8_PLUS(tds) && is_collate_type(curcol->on_server.column_type))
+	if (IS_TDS71_PLUS(tds) && is_collate_type(curcol->on_server.column_type))
 		tds_put_n(tds, tds->collation, 5);
 
 	/* TODO needed in TDS4.2 ?? now is called only is TDS >= 5 */
@@ -1787,7 +1787,7 @@ tds_submit_unprepare(TDSSOCKET * tds, TDSDYNAMIC * dyn)
 		tds->out_flag = TDS_RPC;
 		START_QUERY;
 		/* procedure name */
-		if (IS_TDS8_PLUS(tds)) {
+		if (IS_TDS71_PLUS(tds)) {
 			/* save some byte for mssql2k */
 			tds_put_smallint(tds, -1);
 			tds_put_smallint(tds, TDS_SP_UNPREPARE);
@@ -2165,7 +2165,7 @@ tds_cursor_open(TDSSOCKET * tds, TDSCURSOR * cursor, TDSPARAMINFO *params, int *
 
 		/* procedure identifier by number */
 
-		if (IS_TDS8_PLUS(tds)) {
+		if (IS_TDS71_PLUS(tds)) {
 			tds_put_smallint(tds, -1);
 			tds_put_smallint(tds, TDS_SP_CURSOROPEN);
 		} else {
@@ -2190,7 +2190,7 @@ tds_cursor_open(TDSSOCKET * tds, TDSCURSOR * cursor, TDSPARAMINFO *params, int *
 			tds_put_byte(tds, 0);
 			tds_put_byte(tds, SYBNTEXT);	/* must be Ntype */
 			TDS_PUT_INT(tds, converted_query_len);
-			if (IS_TDS8_PLUS(tds))
+			if (IS_TDS71_PLUS(tds))
 				tds_put_n(tds, tds->collation, 5);
 			TDS_PUT_INT(tds, converted_query_len);
 			tds_put_n(tds, converted_query, (int)converted_query_len);
@@ -2296,7 +2296,7 @@ tds_cursor_setrows(TDSSOCKET * tds, TDSCURSOR * cursor, int *something_to_send)
 static void
 tds7_put_cursor_fetch(TDSSOCKET * tds, TDS_INT cursor_id, TDS_TINYINT fetch_type, TDS_INT i_row, TDS_INT num_rows)
 {
-	if (IS_TDS8_PLUS(tds)) {
+	if (IS_TDS71_PLUS(tds)) {
 		tds_put_smallint(tds, -1);
 		tds_put_smallint(tds, TDS_SP_CURSORFETCH);
 	} else {
@@ -2413,7 +2413,7 @@ tds_cursor_fetch(TDSSOCKET * tds, TDSCURSOR * cursor, TDS_CURSOR_FETCH fetch_typ
 			/* strangely dynamic cursor do not support absolute so emulate it with first + relative */
 			tds7_put_cursor_fetch(tds, cursor->cursor_id, 1, 0, 0);
 			/* TODO define constant */
-			tds_put_byte(tds, IS_TDS90(tds) ? 0xff : 0x80);
+			tds_put_byte(tds, IS_TDS72(tds) ? 0xff : 0x80);
 			tds7_put_cursor_fetch(tds, cursor->cursor_id, 0x20, i_row, cursor->cursor_rows);
 		} else {
 			/* TODO check fetch_type ?? */
@@ -2459,7 +2459,7 @@ tds_cursor_get_cursor_info(TDSSOCKET *tds, TDSCURSOR *cursor, TDS_UINT *prow_num
 		START_QUERY;
 
 		/* Create and send query to server */
-		if (IS_TDS8_PLUS(tds)) {
+		if (IS_TDS71_PLUS(tds)) {
 			tds_put_smallint(tds, -1);
 			tds_put_smallint(tds, TDS_SP_CURSORFETCH);
 		} else {
@@ -2583,7 +2583,7 @@ tds_cursor_close(TDSSOCKET * tds, TDSCURSOR * cursor)
 		tds->out_flag = TDS_RPC;
 		START_QUERY;
 
-		if (IS_TDS8_PLUS(tds)) {
+		if (IS_TDS71_PLUS(tds)) {
 			tds_put_smallint(tds, -1);
 			tds_put_smallint(tds, TDS_SP_CURSORCLOSE);
 		} else {
@@ -2633,7 +2633,7 @@ tds_cursor_setname(TDSSOCKET * tds, TDSCURSOR * cursor)
 	tds->out_flag = TDS_RPC;
 	START_QUERY;
 
-	if (IS_TDS8_PLUS(tds)) {
+	if (IS_TDS71_PLUS(tds)) {
 		tds_put_smallint(tds, -1);
 		tds_put_smallint(tds, TDS_SP_CURSOROPTION);
 	} else {
@@ -2666,7 +2666,7 @@ tds_cursor_setname(TDSSOCKET * tds, TDSCURSOR * cursor)
 	tds_put_byte(tds, XSYBVARCHAR);
 	len = (int)strlen(cursor->cursor_name);
 	tds_put_smallint(tds, len);
-	if (IS_TDS8_PLUS(tds))
+	if (IS_TDS71_PLUS(tds))
 		tds_put_n(tds, tds->collation, 5);
 	tds_put_smallint(tds, len);
 	tds_put_n(tds, cursor->cursor_name, len);
@@ -2709,7 +2709,7 @@ tds_cursor_update(TDSSOCKET * tds, TDSCURSOR * cursor, TDS_CURSOR_OPERATION op,
 		tds->out_flag = TDS_RPC;
 		START_QUERY;
 
-		if (IS_TDS8_PLUS(tds)) {
+		if (IS_TDS71_PLUS(tds)) {
 			tds_put_smallint(tds, -1);
 			tds_put_smallint(tds, TDS_SP_CURSOR);
 		} else {
@@ -2774,7 +2774,7 @@ tds_cursor_update(TDSSOCKET * tds, TDSCURSOR * cursor, TDS_CURSOR_OPERATION op,
 				}
 			}
 			TDS_PUT_SMALLINT(tds, converted_table_len);
-			if (IS_TDS8_PLUS(tds))
+			if (IS_TDS71_PLUS(tds))
 				tds_put_n(tds, tds->collation, 5);
 			TDS_PUT_SMALLINT(tds, converted_table_len);
 			tds_put_n(tds, converted_table, converted_table_len);
@@ -3071,7 +3071,7 @@ tds_multiple_execute(TDSSOCKET *tds, TDSMULTIPLE *multiple, TDSDYNAMIC * dyn)
 	if (IS_TDS7_PLUS(tds)) {
 		if (multiple->flags & MUL_STARTED) {
 			/* TODO define constant */
-			tds_put_byte(tds, IS_TDS90(tds) ? 0xff : 0x80);
+			tds_put_byte(tds, IS_TDS72(tds) ? 0xff : 0x80);
 		}
 		multiple->flags |= MUL_STARTED;
 
diff --git a/src/tds/tds_checks.c b/src/tds/tds_checks.c
index a3bfa1c..108c247 100644
--- a/src/tds/tds_checks.c
+++ b/src/tds/tds_checks.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: tds_checks.c,v 1.25 2009/08/18 15:11:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tds_checks.c,v 1.26 2009/08/25 14:25:35 freddy77 Exp $");
 
 #if ENABLE_EXTRA_CHECKS
 
@@ -204,10 +204,9 @@ tds_check_column_extra(const TDSCOLUMN * column)
 	} else if (column->column_type == SYBVARIANT) {
 		assert(column->column_varint_size == 4);
 	}
-	tds.minor_version = 0;
-	tds.major_version = 5;
+	tds.tds_version = 0x500;
 	varint_ok = varint_ok || tds_get_varint_size(&tds, column->on_server.column_type) == column->column_varint_size;
-	tds.major_version = 7;
+	tds.tds_version = 0x700;
 	varint_ok = varint_ok || tds_get_varint_size(&tds, column->on_server.column_type) == column->column_varint_size;
 	assert(varint_ok);
 
diff --git a/src/tds/token.c b/src/tds/token.c
index 22cfb0a..0223375 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.372 2009/08/21 10:11:20 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.373 2009/08/25 14:25:35 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -1100,7 +1100,7 @@ tds_process_tabname(TDSSOCKET *tds)
 	hdrsize = tds_get_smallint(tds);
 
 	/* different structure for tds8 */
-	if (IS_TDS8_PLUS(tds))
+	if (IS_TDS71_PLUS(tds))
 		num_names = tds8_read_table_names(tds, hdrsize, &head);
 	else
 		num_names = tds_read_namelist(tds, hdrsize, &head, 1);
@@ -1419,7 +1419,7 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	CHECK_COLUMN_EXTRA(curcol);
 
 	/*  User defined data type of the column */
-	curcol->column_usertype = IS_TDS90(tds) ? tds_get_int(tds) : tds_get_smallint(tds);
+	curcol->column_usertype = IS_TDS72(tds) ? tds_get_int(tds) : tds_get_smallint(tds);
 
 	curcol->column_flags = tds_get_smallint(tds);	/*  Flags */
 
@@ -1441,7 +1441,7 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	case 2:
 		curcol->column_size = tds_get_smallint(tds);
 		/* under TDS9 this means ?var???(MAX) */
-		if (curcol->column_size < 0 && IS_TDS90(tds)) {
+		if (curcol->column_size < 0 && IS_TDS72(tds)) {
 			curcol->column_size = 0x3ffffffflu;
 			curcol->column_varint_size = 8;
 		}
@@ -1463,7 +1463,7 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		/* FIXME check prec/scale, don't let server crash us */
 	}
 
-	if (IS_TDS8_PLUS(tds) && is_collate_type(curcol->on_server.column_type)) {
+	if (IS_TDS71_PLUS(tds) && is_collate_type(curcol->on_server.column_type)) {
 		/* based on true type as sent by server */
 		/*
 		 * first 2 bytes are windows code (such as 0x409 for english)
@@ -1481,11 +1481,11 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	if (is_blob_type(curcol->column_type)) {
 		/* discard this additional byte */
 		/* TODO discover its meaning */
-		if (IS_TDS90(tds))
+		if (IS_TDS72(tds))
 			tds_get_byte(tds);
 		curcol->table_namelen =
 			tds_get_string(tds, tds_get_smallint(tds), curcol->table_name, sizeof(curcol->table_name) - 1);
-	} else if (IS_TDS90(tds) && curcol->column_type == SYBMSXML)
+	} else if (IS_TDS72(tds) && curcol->column_type == SYBMSXML)
 		tds_get_byte(tds);
 
 	/*
@@ -1619,7 +1619,7 @@ tds_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int is_param)
 			, might_be_nullable	= 0x0800 
 		};
 		/* TODO: implement members in TDSCOLUMN */
-		if (IS_TDS90(tds)) {
+		if (IS_TDS72(tds)) {
 			curcol->is_computed = 		(curcol->column_flags & (1 << 4)) > 1;
 			curcol->us_reserved_odbc1 = 	(curcol->column_flags & (1 << 5)) > 1;
 			curcol->us_reserved_odbc2 = 	(curcol->column_flags & (1 << 6)) > 1;
@@ -1628,7 +1628,7 @@ tds_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int is_param)
 #endif 
 	} 
 
-	if (IS_TDS90(tds)) {
+	if (IS_TDS72(tds)) {
 		tds_get_n(tds, NULL, 2);
 #if 0
 		/* TODO: implement members in TDSCOLUMN, values untested */
@@ -1677,7 +1677,7 @@ tds_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int is_param)
 
 	/* read sql collation info */
 	/* TODO: we should use it ! */
-	if (IS_TDS8_PLUS(tds) && is_collate_type(curcol->on_server.column_type)) {
+	if (IS_TDS71_PLUS(tds) && is_collate_type(curcol->on_server.column_type)) {
 		tds_get_n(tds, curcol->column_collation, 5);
 		curcol->char_conv =
 			tds_iconv_from_collate(tds, curcol->column_collation);
@@ -2413,7 +2413,7 @@ tds_process_end(TDSSOCKET * tds, int marker, int *flags_parm)
 	 * have no result set.
 	 */
 
-	rows_affected = IS_TDS90(tds) ? tds_get_int8(tds) : tds_get_int(tds);
+	rows_affected = IS_TDS72(tds) ? tds_get_int8(tds) : tds_get_int(tds);
 	tdsdump_log(TDS_DBG_FUNC, "                rows_affected = %" TDS_I64_FORMAT "\n", rows_affected);
 	if (done_count_valid)
 		tds->rows_affected = rows_affected;
@@ -2496,7 +2496,7 @@ tds_process_env_chg(TDSSOCKET * tds)
 
 	/* discard byte values, not still supported */
 	/* TODO support them */
-	if (IS_TDS8_PLUS(tds) && type > TDS_ENV_PACKSIZE) {
+	if (IS_TDS71_PLUS(tds) && type > TDS_ENV_PACKSIZE) {
 		/* discard new one */
 		tds_get_n(tds, NULL, tds_get_byte(tds));
 		/* discard old one */
@@ -2653,7 +2653,7 @@ tds_process_msg(TDSSOCKET * tds, int marker)
 	rc += tds_alloc_get_string(tds, &msg.proc_name, tds_get_byte(tds));
 
 	/* line number in the sql statement where the problem occured */
-	msg.line_number = IS_TDS90(tds) ? tds_get_int(tds) : tds_get_smallint(tds);
+	msg.line_number = IS_TDS72(tds) ? tds_get_int(tds) : tds_get_smallint(tds);
 
 	/*
 	 * If the server doesen't provide an sqlstate, map one via server native errors
diff --git a/src/tds/util.c b/src/tds/util.c
index 6b6cd48..c4034d8 100644
--- a/src/tds/util.c
+++ b/src/tds/util.c
@@ -65,7 +65,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: util.c,v 1.86 2009/04/18 19:35:38 jklowden Exp $");
+TDS_RCSID(var, "$Id: util.c,v 1.87 2009/08/25 14:25:35 freddy77 Exp $");
 
 void
 tds_set_parent(TDSSOCKET * tds, void *the_parent)
@@ -194,10 +194,10 @@ tds_version(TDSSOCKET * tds_socket, char *pversion_string)
 	int iversion = 0;
 
 	if (tds_socket) {
-		iversion = 10 * tds_socket->major_version + tds_socket->minor_version;
+		iversion = 10 * TDS_MAJOR(tds_socket) + TDS_MINOR(tds_socket);
 
 		if (pversion_string) {
-			sprintf(pversion_string, "%d.%d", tds_socket->major_version, tds_socket->minor_version);
+			sprintf(pversion_string, "%d.%d", TDS_MAJOR(tds_socket), TDS_MINOR(tds_socket));
 		}
 	}
 
diff --git a/win32/winsetup.c b/win32/winsetup.c
index e33dc76..6970710 100644
--- a/win32/winsetup.c
+++ b/win32/winsetup.c
@@ -159,7 +159,7 @@ write_all_strings(DSNINFO * di)
 	sprintf(tmp, "%u", di->connection->port);
 	WRITESTR("Port", tmp);
 
-	sprintf(tmp, "%d.%d", di->connection->major_version, di->connection->minor_version);
+	sprintf(tmp, "%d.%d", TDS_MAJOR(di->connection), TDS_MINOR(di->connection));
 	WRITESTR("TDS_Version", tmp);
 
 	sprintf(tmp, "%u", di->connection->text_size);
@@ -215,7 +215,7 @@ DSNDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
 	const char *pstr;
 	int major, minor, i;
 	static const char *protocols[] = {
-		"TDS 4.2", "TDS 4.6", "TDS 5.0", "TDS 7.0", "TDS 8.0", NULL
+		"TDS 4.2", "TDS 4.6", "TDS 5.0", "TDS 7.0", "TDS 7.1", "TDS 7.2", NULL
 	};
 
 	switch (message) {
@@ -232,7 +232,7 @@ DSNDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
 
 		/* copy info from DSNINFO to the dialog */
 		SendDlgItemMessage(hDlg, IDC_DSNNAME, WM_SETTEXT, 0, (LPARAM) tds_dstr_cstr(&di->dsn));
-		sprintf(tmp, "TDS %d.%d", di->connection->major_version, di->connection->minor_version);
+		sprintf(tmp, "TDS %d.%d", TDS_MAJOR(di->connection), TDS_MINOR(di->connection));
 		SendDlgItemMessage(hDlg, IDC_PROTOCOL, CB_SELECTSTRING, -1, (LPARAM) tmp);
 		SendDlgItemMessage(hDlg, IDC_ADDRESS, WM_SETTEXT, 0, (LPARAM) tds_dstr_cstr(&di->connection->server_name));
 		sprintf(tmp, "%u", di->connection->port);
@@ -261,8 +261,11 @@ DSNDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
 		SendDlgItemMessage(hDlg, IDC_PROTOCOL, WM_GETTEXT, sizeof tmp, (LPARAM) tmp);
 		minor = 0;
 		if (sscanf(tmp, "%*[^0-9]%d.%d", &major, &minor) > 1) {
-			di->connection->major_version = major;
-			di->connection->minor_version = minor;
+			if (major == 8 && minor == 0) {
+				major = 7;
+				minor = 1;
+			}
+			di->connection->tds_version = (major << 8) | minor;
 		}
 		SendDlgItemMessage(hDlg, IDC_ADDRESS, WM_GETTEXT, sizeof tmp, (LPARAM) tmp);
 		tds_dstr_copy(&di->connection->server_name, tmp);

